`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/01 19:35:26
// Design Name: 
// Module Name: AM_PM_selector
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`define MODE_24 1'b1
`define MODE_12 1'b0
module AM_PM_selector(
    hour_in_1,
    hour_in_0,
    hour_out_1,
    hour_out_0,
    AM_PM_convert,
    select_mode
    );
    
    output reg [3:0] hour_out_0, hour_out_1;
    input [3:0] hour_in_0, hour_in_1;
    input select_mode, AM_PM_convert;

    always @*
    begin
      if (select_mode == `MODE_24)
        begin
          hour_out_1 = hour_in_1;
          hour_out_0 = hour_in_0;
        end
      else if (AM_PM_convert == 1'b1)
        case ({hour_in_1, hour_in_0})
          8'b0001_0010: //12
            begin
                hour_out_1 = 4'd1;
                hour_out_0 = 4'd2;
            end
          8'b0001_0011: //13
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd1;
            end
          8'b0001_0100: //14
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd2;
            end
          8'b0001_0101: //15
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd3;
            end
          8'b0001_0110: //16
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd4;
            end
          8'b0001_0111: //17
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd5;
            end
          8'b0001_1000: //18
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd6;
            end
          8'b0001_1001: //19
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd7;
            end
          8'b0010_0000: //20
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd8;
            end
          8'b0010_0001: //21
            begin
                hour_out_1 = 4'd0;
                hour_out_0 = 4'd9;
            end
          8'b0010_0010: //22
            begin
                hour_out_1 = 4'd1;
                hour_out_0 = 4'd0;
            end
          8'b0010_0011: //23
            begin
                hour_out_1 = 4'd1;
                hour_out_0 = 4'd1;
            end
          default:
            begin 
                hour_out_1 = hour_in_1;
                hour_out_0 = hour_in_0;
            end
        endcase
      else
        if (hour_in_1 == 4'd0 && hour_in_0 == 4'd0)
            begin
            hour_out_1 = 4'd1;
            hour_out_0 = 4'd2;
            end
        else
            begin
            hour_out_1 = hour_in_1;
            hour_out_0 = hour_in_0;
            end
    end
endmodule




