`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 2019/04/04 19:35:26
// Design Name: 
// Module Name: BCD_up_year
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////
`define ENABLE 1'b1
`define DISABLE 1'b0
`define FEB28 16'b0000_0010_0010_1000
`define FEB29 16'b0000_0010_0010_1001 
module BCD_up_month_date(
    digit_3,
    digit_2,
    digit_1,
    digit_0,
    rst_n,
    clk,
    en,
    cout,
    leap_year
    );
    output [3:0] digit_0, digit_1, digit_2, digit_3;
    output cout;
    input clk, rst_n, en, leap_year;
    
    wire c0, c1, c2;
    reg rst_day;
    reg rst_month;
    reg [15:0] feb;

    always @*
        if (leap_year)
          feb = `FEB29;
        else
          feb = `FEB28;

    always @*
        case ({digit_3, digit_2, digit_1, digit_0})
          16'b0000_0001_0011_0001: //Jan 31
            begin
                rst_day = `ENABLE; 
            end
          feb: //Feb 28 or 29
            begin
                rst_day = `ENABLE;
            end
          16'b0000_0011_0011_0001: //Mar 31
            begin
                rst_day = `ENABLE;
            end
          16'b0000_0100_0011_0000: //Apr 30
            begin
                rst_day = `ENABLE;
            end
          16'b0000_0101_0011_0001: //May 31
            begin
                rst_day = `ENABLE;
            end
          16'b0000_0110_0011_0000: //Jun 30
            begin
                rst_day = `ENABLE;
            end
          16'b0000_0111_0011_0001: //Jul 31
            begin
                rst_day = `ENABLE;
            end
          16'b0000_1000_0011_0001: //Aug 31
            begin
                rst_day = `ENABLE;
            end
          16'b0000_1001_0011_0000: //Sep 30
            begin
                rst_day = `ENABLE;
            end
          16'b0001_0000_0011_0001: //Oct 31
            begin
                rst_day = `ENABLE;
            end
          16'b0001_0001_0011_0000: //Nov 30
            begin
                rst_day = `ENABLE;
            end
          16'b0001_0010_0011_0001: //Dec 31
            begin
                rst_day = `ENABLE;
            end
          default:
            begin 
                rst_day = `DISABLE;
            end
        endcase
    
    
    always @*
        if (digit_3 == 4'd1 && digit_2 == 4'd2) //digit_3, digit_2 mean when arriving December, then reset
            rst_month = `ENABLE;
        else
            rst_month = `DISABLE;


    BCD_up_day U0(
    .value(digit_0), 
    .carry_out(c0), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(en),
    .init_value(4'd7), 
    .limit(4'd9),
    .rst_hour(rst_day)
    );
    
    BCD_up U1(
    .value(digit_1), 
    .carry_out(c1), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c0),
    .init_value(4'd2), 
    .limit(4'd3),
    .rst_hour(rst_day)
    );

    BCD_up_day U2(
    .value(digit_2), 
    .carry_out(c2), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c1),
    .init_value(4'd2), 
    .limit(4'd9),
    .rst_hour(rst_month)
    );

    BCD_up U3(
    .value(digit_3), 
    .carry_out(cout), 
    .clk(clk), 
    .rst_n(rst_n), 
    .increase(c2),
    .init_value(4'd0), 
    .limit(4'd1),
    .rst_hour(rst_month)
    );

endmodule




